summaryrefslogtreecommitdiffstats
path: root/graphics/mitsuba2
diff options
context:
space:
mode:
author klaatu2022-03-08 16:49:00 +0100
committer Willy Sudiarto Raharjo2022-03-09 03:07:59 +0100
commitc76b204b9c2b628eb2223a959ef40194b267a83a (patch)
treefd0cb2b5828b413501b13cc2a588d6533edb04a2 /graphics/mitsuba2
parent6c68f43b75f3f4f7b01664e65a995bca697fcb2b (diff)
downloadslackbuilds-c76b204b9c2b628eb2223a959ef40194b267a83a.tar.gz
graphics/mitsuba2: Added (replacement of mitsuba).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'graphics/mitsuba2')
-rw-r--r--graphics/mitsuba2/README31
-rw-r--r--graphics/mitsuba2/doinst.sh4
-rw-r--r--graphics/mitsuba2/mitsuba2.SlackBuild108
-rw-r--r--graphics/mitsuba2/mitsuba2.info10
-rw-r--r--graphics/mitsuba2/slack-desc19
5 files changed, 172 insertions, 0 deletions
diff --git a/graphics/mitsuba2/README b/graphics/mitsuba2/README
new file mode 100644
index 0000000000..d646cd4980
--- /dev/null
+++ b/graphics/mitsuba2/README
@@ -0,0 +1,31 @@
+mitsuba (computer graphics renderer)
+
+Mitsuba is a 3D rendering engine placing emphasis
+on experimental rendering techniques.
+
+This SlackBuild is based on a Git commit from 8 March 2022.
+It compiles from source code, and installs to /opt with a
+symlink to the `mitsuba` binary in `/usr/bin`
+
+## Documentation
+
+To build docs, you must have Sphinx and assorted Sphinx plugins
+installed. These are available through `pip`:
+
+```
+$ python3 -m pip install sphinx \
+ sphinxcontrib-bibtex \
+ guzzle_sphinx_theme
+```
+
+This SlackBuild doesn't build the docs by default. To enable
+the docs, set the `DOCS` variable to `yes` as you build:
+
+```
+DOCS=yes sh ./mitsuba2.SlackBuild
+```
+
+## See also
+
+There is a Mitsuba Blender plugin available from
+https://github.com/mitsuba-renderer/mitsuba2-blender
diff --git a/graphics/mitsuba2/doinst.sh b/graphics/mitsuba2/doinst.sh
new file mode 100644
index 0000000000..4e8ba7071d
--- /dev/null
+++ b/graphics/mitsuba2/doinst.sh
@@ -0,0 +1,4 @@
+if [ -x /usr/bin/update-desktop-database ]; then
+ /usr/bin/update-desktop-database -q usr/share/applications >/dev/null 2>&1
+fi
+
diff --git a/graphics/mitsuba2/mitsuba2.SlackBuild b/graphics/mitsuba2/mitsuba2.SlackBuild
new file mode 100644
index 0000000000..bd7005f7c9
--- /dev/null
+++ b/graphics/mitsuba2/mitsuba2.SlackBuild
@@ -0,0 +1,108 @@
+#!/bin/bash
+
+# Copyright 2014-22 Klaatu, Wellington NZ
+# GNU All-Permissive License
+# Copying and distribution of this file, with or without modification,
+# are permitted in any medium without royalty provided the copyright
+# notice and this notice are preserved. This file is offered as-is,
+# without any warranty.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=mitsuba2
+VERSION=${VERSION:-4e7628c}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+# If PRINT_PACKAGE_NAME is set, print name of package
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.xz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+cmake -GNinja \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DMAN_INSTALL_DIR=/usr/man \
+ -DCMAKE_BUILD_TYPE=Release ..
+ninja
+
+# no install option provided, so copy compiled code to /opt
+mkdir -p $PKG/opt
+mv dist $PKG/opt/$PRGNAM-$VERSION
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/bin
+ln -s $PKG/opt/$PRGNAM-$VERSION/mitsuba $PKG/usr/bin/mitsuba
+
+cd ..
+
+# sample scenes
+mkdir -p $PKG/usr/share/$PRGNAM-$VERSION
+cp -a resources $PKG/usr/share/$PRGNAM-$VERSION
+
+# docs
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a setpath.sh $PKG/usr/doc/$PRGNAM-$VERSION
+cp LICENSE README.md $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+# generated docs
+if [ "$DOCS" ]; then
+ mkdir $PKG/usr/doc/$PRGNAM-$VERSION/html
+ sphinx docs $PKG/usr/doc/$PRGNAM-$VERSION/html
+fi
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/graphics/mitsuba2/mitsuba2.info b/graphics/mitsuba2/mitsuba2.info
new file mode 100644
index 0000000000..0f8fcc7e60
--- /dev/null
+++ b/graphics/mitsuba2/mitsuba2.info
@@ -0,0 +1,10 @@
+PRGNAM="mitsuba2"
+VERSION="4e7628c"
+HOMEPAGE="http://mitsuba-renderer.org"
+DOWNLOAD="http://slackermedia.info/slackbuilds/mitsuba/src/mitsuba2-4e7628c.tar.xz"
+MD5SUM="da4706ad68676b86d477ea3d3374f986"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="klaatu"
+EMAIL="klaatu@member.fsf.org"
diff --git a/graphics/mitsuba2/slack-desc b/graphics/mitsuba2/slack-desc
new file mode 100644
index 0000000000..907cb9bcf0
--- /dev/null
+++ b/graphics/mitsuba2/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+mitsuba2: mitsuba2 (computer graphics renderer)
+mitsuba2:
+mitsuba2: A modular, experimental graphics renderer, placing an emphasis
+mitsuba2: upon experimental techniques.
+mitsuba2:
+mitsuba2: Homepage: http://mitsuba-renderer.org
+mitsuba2:
+mitsuba2:
+mitsuba2:
+mitsuba2:
+mitsuba2: